searchNodes=[{"type":"module","title":"ExM3U8","doc":"ExM3u8 A library for deserializing and serializing M3U8 format (known from HLS). Functionality The whole package operates on 2 types of playlists mentioned in HLS specification . Multivariant playlist Media playlist Multivariant playlist is responsible for listing available renditions (video, audio and subtitle tracks). Each variant is represented by its own media playlist which lists media segments that are necessary to start a proper playback. Note Due to the large number of tags in the HLS spec, the library for now only supports the essential ones. If a tag is missing a user may want to implement a custom tag parser or create a PR with a support for the new tag.","ref":"ExM3U8.html"},{"type":"function","title":"ExM3U8.deserialize_media_playlist/2","doc":"Deserializes given playlist string into a media playlist structure.","ref":"ExM3U8.html#deserialize_media_playlist/2"},{"type":"function","title":"ExM3U8.deserialize_media_playlist!/2","doc":"Sames as deserialize_media_playlist/2 but raises on error.","ref":"ExM3U8.html#deserialize_media_playlist!/2"},{"type":"function","title":"ExM3U8.deserialize_multivariant_playlist/2","doc":"Deserialies given playlist string into a multivariant playlist structure.","ref":"ExM3U8.html#deserialize_multivariant_playlist/2"},{"type":"function","title":"ExM3U8.deserialize_multivariant_playlist!/2","doc":"","ref":"ExM3U8.html#deserialize_multivariant_playlist!/2"},{"type":"function","title":"ExM3U8.deserialize_playlist/2","doc":"Tries to deserialize playlist string into either a multivariant playlist or a media playlist. Note that this function first tries to deserialize a multivariant playlist and if it failes it tries to deserialize a media playlist so any errors from multivariant playlist parsing will be ignored and the eventual error will come from media playlist parsing.","ref":"ExM3U8.html#deserialize_playlist/2"},{"type":"function","title":"ExM3U8.deserialize_playlist!/2","doc":"Same as deserialize_playlist/2 but raises on error.","ref":"ExM3U8.html#deserialize_playlist!/2"},{"type":"function","title":"ExM3U8.serialize/1","doc":"Serializes given playlist into a string.","ref":"ExM3U8.html#serialize/1"},{"type":"type","title":"ExM3U8.custom_tag_parser_reusult_t/0","doc":"","ref":"ExM3U8.html#t:custom_tag_parser_reusult_t/0"},{"type":"type","title":"ExM3U8.custom_tag_parser_t/0","doc":"Signature of a custom tag parser function. A custom parser is called on each line that a built-in parser couldn't handle. As an input it receives the current line and the remaining lines of the original string. As a result it should either skip the current lilne, return a tag and new list of remaining lines (handling a targ could take several lines) or return an error. Note that the custom parser will be only used for tags/lines that haven't been handled by the built-in parser so it can't override the default handling of supported tags.","ref":"ExM3U8.html#t:custom_tag_parser_t/0"},{"type":"type","title":"ExM3U8.deserialize_opt_t/0","doc":"","ref":"ExM3U8.html#t:deserialize_opt_t/0"},{"type":"protocol","title":"ExM3U8.Serializer","doc":"Protocol for serializing playlist tags into iodata that is further used for generating manifest string.","ref":"ExM3U8.Serializer.html"},{"type":"function","title":"ExM3U8.Serializer.serialize/1","doc":"","ref":"ExM3U8.Serializer.html#serialize/1"},{"type":"type","title":"ExM3U8.Serializer.t/0","doc":"All the types that implement this protocol.","ref":"ExM3U8.Serializer.html#t:t/0"},{"type":"module","title":"ExM3U8.Tags.ByteRange","doc":"Structure representing byte range of the following media segment/chunk.","ref":"ExM3U8.Tags.ByteRange.html"},{"type":"type","title":"ExM3U8.Tags.ByteRange.t/0","doc":"","ref":"ExM3U8.Tags.ByteRange.html#t:t/0"},{"type":"module","title":"ExM3U8.Tags.ContentSteering","doc":"Structure representing a content steering tag.","ref":"ExM3U8.Tags.ContentSteering.html"},{"type":"type","title":"ExM3U8.Tags.ContentSteering.t/0","doc":"","ref":"ExM3U8.Tags.ContentSteering.html#t:t/0"},{"type":"module","title":"ExM3U8.Tags.Discontinuity","doc":"Structure representing media discontinuity.","ref":"ExM3U8.Tags.Discontinuity.html"},{"type":"type","title":"ExM3U8.Tags.Discontinuity.t/0","doc":"","ref":"ExM3U8.Tags.Discontinuity.html#t:t/0"},{"type":"module","title":"ExM3U8.Tags.Key","doc":"Structure representing a key tag.","ref":"ExM3U8.Tags.Key.html"},{"type":"type","title":"ExM3U8.Tags.Key.method/0","doc":"","ref":"ExM3U8.Tags.Key.html#t:method/0"},{"type":"type","title":"ExM3U8.Tags.Key.t/0","doc":"","ref":"ExM3U8.Tags.Key.html#t:t/0"},{"type":"module","title":"ExM3U8.Tags.Media","doc":"Structure representing a media tag.","ref":"ExM3U8.Tags.Media.html"},{"type":"type","title":"ExM3U8.Tags.Media.t/0","doc":"","ref":"ExM3U8.Tags.Media.html#t:t/0"},{"type":"module","title":"ExM3U8.Tags.MediaInit","doc":"Structre represening media initialization section of for media segments.","ref":"ExM3U8.Tags.MediaInit.html"},{"type":"type","title":"ExM3U8.Tags.MediaInit.t/0","doc":"","ref":"ExM3U8.Tags.MediaInit.html#t:t/0"},{"type":"module","title":"ExM3U8.Tags.Part","doc":"Structure representing a media part (partial segment/chunk).","ref":"ExM3U8.Tags.Part.html"},{"type":"type","title":"ExM3U8.Tags.Part.t/0","doc":"","ref":"ExM3U8.Tags.Part.html#t:t/0"},{"type":"module","title":"ExM3U8.Tags.PreloadHint","doc":"Structure representing a preload hint present in a media playlist.","ref":"ExM3U8.Tags.PreloadHint.html"},{"type":"type","title":"ExM3U8.Tags.PreloadHint.t/0","doc":"","ref":"ExM3U8.Tags.PreloadHint.html#t:t/0"},{"type":"module","title":"ExM3U8.Tags.ProgramDateTime","doc":"Structure representing program date time of the following media segment/chunk.","ref":"ExM3U8.Tags.ProgramDateTime.html"},{"type":"type","title":"ExM3U8.Tags.ProgramDateTime.t/0","doc":"","ref":"ExM3U8.Tags.ProgramDateTime.html#t:t/0"},{"type":"module","title":"ExM3U8.Tags.RenditionReport","doc":"Structure representing a rendition report.","ref":"ExM3U8.Tags.RenditionReport.html"},{"type":"type","title":"ExM3U8.Tags.RenditionReport.t/0","doc":"","ref":"ExM3U8.Tags.RenditionReport.html#t:t/0"},{"type":"module","title":"ExM3U8.Tags.Segment","doc":"Structure representing a media segment.","ref":"ExM3U8.Tags.Segment.html"},{"type":"type","title":"ExM3U8.Tags.Segment.t/0","doc":"","ref":"ExM3U8.Tags.Segment.html#t:t/0"},{"type":"module","title":"ExM3U8.Tags.Skip","doc":"Structure representing a media segment.","ref":"ExM3U8.Tags.Skip.html"},{"type":"type","title":"ExM3U8.Tags.Skip.t/0","doc":"","ref":"ExM3U8.Tags.Skip.html#t:t/0"},{"type":"module","title":"ExM3U8.Tags.Stream","doc":"Structure representing a single media stream information. Tag is present only in multivariant playlists.","ref":"ExM3U8.Tags.Stream.html"},{"type":"type","title":"ExM3U8.Tags.Stream.t/0","doc":"","ref":"ExM3U8.Tags.Stream.html#t:t/0"},{"type":"module","title":"ExM3U8.MediaPlaylist","doc":"Structure representing a media playlist.","ref":"ExM3U8.MediaPlaylist.html"},{"type":"type","title":"ExM3U8.MediaPlaylist.custom_tag_t/0","doc":"","ref":"ExM3U8.MediaPlaylist.html#t:custom_tag_t/0"},{"type":"type","title":"ExM3U8.MediaPlaylist.t/0","doc":"","ref":"ExM3U8.MediaPlaylist.html#t:t/0"},{"type":"module","title":"ExM3U8.MultivariantPlaylist","doc":"Structure representing a multivariant playlist.","ref":"ExM3U8.MultivariantPlaylist.html"},{"type":"type","title":"ExM3U8.MultivariantPlaylist.custom_tag_t/0","doc":"","ref":"ExM3U8.MultivariantPlaylist.html#t:custom_tag_t/0"},{"type":"type","title":"ExM3U8.MultivariantPlaylist.t/0","doc":"","ref":"ExM3U8.MultivariantPlaylist.html#t:t/0"},{"type":"module","title":"ExM3U8.MediaPlaylist.Info","doc":"Structure representing media's playlist information.","ref":"ExM3U8.MediaPlaylist.Info.html"},{"type":"type","title":"ExM3U8.MediaPlaylist.Info.t/0","doc":"","ref":"ExM3U8.MediaPlaylist.Info.html#t:t/0"},{"type":"module","title":"ExM3U8.MediaPlaylist.ServerControl","doc":"Structure representing server's control information of media playlist.","ref":"ExM3U8.MediaPlaylist.ServerControl.html"},{"type":"type","title":"ExM3U8.MediaPlaylist.ServerControl.t/0","doc":"","ref":"ExM3U8.MediaPlaylist.ServerControl.html#t:t/0"},{"type":"extras","title":"ExM3U8","doc":"A library for deserializing and serializing M3U8 format (known from HLS).","ref":"readme.html"},{"type":"extras","title":"ExM3U8 - Install","doc":"The package can be installed by adding ex_m3u8 into your list of dependencies in mix.exs : def deps do [ { :ex_m3u8 , &quot;~&gt; 0.11.0&quot; } ] end","ref":"readme.html#install"},{"type":"extras","title":"ExM3U8 - Functionality","doc":"The whole package operates on 2 types of playlists mentioned in HLS specification . Multivariant playlist Media playlist Multivariant playlist is responsible for listing available renditions (video, audio and subtitle tracks). Each variant is represented by its own media playlist which lists media segments that are necessary to start a proper playback.","ref":"readme.html#functionality"},{"type":"extras","title":"ExM3U8 - Usage","doc":"The library provides 4 public functions (and their '!' versions) that can be used by library's users ExM3U8.serialize/1 ExM3U8.deserialize_playlist/2 ExM3U8.deserialize_media_playlist/2 ExM3U8.deserialize_multivariant_playlist/2 Note Due to the large number of tags in the HLS spec, the library for now only supports the essential ones. If a tag is missing a user may want to implement a custom tag parser or create a PR with a support for the new tag.","ref":"readme.html#usage"},{"type":"extras","title":"ExM3U8 - Copyright and License","doc":"Copyright 2024, Software Mansion Licensed under the Apache License, Version 2.0","ref":"readme.html#copyright-and-license"},{"type":"extras","title":"LICENSE","doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright 2020 Software Mansion Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html"}]